Index: /trunk/src/sys/arch/mips/mips/vm_machdep.c
===================================================================
--- /trunk/src/sys/arch/mips/mips/vm_machdep.c	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/vm_machdep.c	(revision 152)
@@ -1,5 +1,6 @@
-/*	$NetBSD: vm_machdep.c,v 1.121.6.1.2.14 2010/03/01 19:27:21 matt Exp $	*/
-
-/*
+/*	vm_machdep.c,v 1.121.6.1.2.19 2011/04/29 08:26:31 matt Exp	*/
+
+/*
+ * Copyright (c) 1988 University of Utah.
  * Copyright (c) 1992, 1993
  *	The Regents of the University of California.  All rights reserved.
@@ -37,49 +38,10 @@
  *	@(#)vm_machdep.c	8.3 (Berkeley) 1/4/94
  */
-/*
- * Copyright (c) 1988 University of Utah.
- *
- * This code is derived from software contributed to Berkeley by
- * the Systems Programming Group of the University of Utah Computer
- * Science Department and Ralph Campbell.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- * 3. All advertising materials mentioning features or use of this software
- *    must display the following acknowledgement:
- *	This product includes software developed by the University of
- *	California, Berkeley and its contributors.
- * 4. Neither the name of the University nor the names of its contributors
- *    may be used to endorse or promote products derived from this software
- *    without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
- * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
- * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
- * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
- * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
- * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
- * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
- * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
- * SUCH DAMAGE.
- *
- * from: Utah Hdr: vm_machdep.c 1.21 91/04/06
- *
- *	@(#)vm_machdep.c	8.3 (Berkeley) 1/4/94
- */
+
+#include <sys/cdefs.h>
+__KERNEL_RCSID(0, "vm_machdep.c,v 1.121.6.1.2.19 2011/04/29 08:26:31 matt Exp");
 
 #include "opt_ddb.h"
 #include "opt_coredump.h"
-
-#include <sys/cdefs.h>			/* RCS ID & Copyright macro defns */
-__KERNEL_RCSID(0, "$NetBSD: vm_machdep.c,v 1.121.6.1.2.14 2010/03/01 19:27:21 matt Exp $");
 
 #include <sys/param.h>
@@ -88,6 +50,6 @@
 #include <sys/malloc.h>
 #include <sys/buf.h>
+#include <sys/cpu.h>
 #include <sys/vnode.h>
-#include <sys/user.h>
 #include <sys/core.h>
 #include <sys/exec.h>
@@ -95,32 +57,31 @@
 #include <sys/savar.h>
 
-#include <uvm/uvm_extern.h>
+#include <uvm/uvm.h>
 
 #include <mips/cache.h>
+#include <mips/pcb.h>
 #include <mips/regnum.h>
 #include <mips/locore.h>
 #include <mips/pte.h>
 #include <mips/psl.h>
-#include <machine/cpu.h>
 
 paddr_t kvtophys(vaddr_t);	/* XXX */
 
 /*
- * Finish a fork operation, with lwp l2 nearly set up.
+ * cpu_lwp_fork: Finish a fork operation, with lwp l2 nearly set up.
  * Copy and update the pcb and trapframe, making the child ready to run.
  *
- * Rig the child's kernel stack so that it will start out in
- * lwp_trampoline() and call child_return() with l2 as an
- * argument. This causes the newly-created child process to go
- * directly to user level with an apparent return value of 0 from
- * fork(), while the parent process returns normally.
- *
- * l1 is the process being forked; if l1 == &lwp0, we are creating
- * a kernel thread, and the return path and argument are specified with
- * `func' and `arg'.
+ * First LWP (l1) is the lwp being forked.  If it is &lwp0, then we are
+ * creating a kthread, where return path and argument are specified
+ * with `func' and `arg'.
+ *
+ * Rig the child's kernel stack so that it will start out in lwp_trampoline()
+ * and call child_return() with l2 as an argument. This causes the
+ * newly-created child process to go directly to user level with an apparent
+ * return value of 0 from fork(), while the parent process returns normally.
  *
  * If an alternate user-level stack is requested (with non-zero values
- * in both the stack and stacksize args), set up the user stack pointer
- * accordingly.
+ * in both the stack and stacksize arguments), then set up the user stack
+ * pointer accordingly.
  */
 void
@@ -128,10 +89,8 @@
     void (*func)(void *), void *arg)
 {
-	struct pcb *pcb;
+	struct pcb * const pcb1 = lwp_getpcb(l1);
+	struct pcb * const pcb2 = lwp_getpcb(l2);
 	struct trapframe *tf;
-#ifndef TSAR
-	pt_entry_t *pte;
-	int i, x;
-#endif
+	KASSERT(l1 == curlwp || l1 == &lwp0);
 
 	l2->l_md.md_ss_addr = 0;
@@ -139,28 +98,21 @@
 	l2->l_md.md_astpending = 0;
 
-#ifdef DIAGNOSTIC
-	/*
-	 * If l1 != curlwp && l1 == &lwp0, we're creating a kernel thread.
-	 */
-	if (l1 != curlwp && l1 != &lwp0)
-		panic("cpu_lwp_fork: curlwp");
-#endif
 #ifndef NOFPU
-	if (l1->l_md.md_flags & MDP_FPUSED)
-		fpusave_lwp(l1);
-#endif
-
-	/*
-	 * Copy pcb from lwp l1 to l2.
-	 * Copy l1 trapframe atop on l2 stack space, so return to user mode
+	/* If parent LWP was using FPU, then save the FPU h/w state. */
+	fpu_save_lwp(l1);
+#endif
+
+	/* Copy the PCB from parent. */
+	*pcb2 = *pcb1;
+
+	/*
+	 * Copy the trapframe from parent, so that return to userspace
 	 * will be to right address, with correct registers.
 	 */
-	l2->l_addr->u_pcb = l1->l_addr->u_pcb;
-	tf = (struct trapframe *)((char *)l2->l_addr + USPACE) - 1;
+	vaddr_t ua2 = (vaddr_t)l2->l_addr;
+	tf = (struct trapframe *)(ua2 + USPACE) - 1;
 	*tf = *l1->l_md.md_utf;
 
-	/*
-	 * If specified, give the child a different stack.
-	 */
+	/* If specified, set a different user stack for a child. */
 	if (stack != NULL)
 		tf->tf_regs[_R_SP] = (intptr_t)stack + stacksize;
@@ -173,35 +125,37 @@
 
 #ifndef TSAR
-	x = (MIPS_HAS_R4K_MMU) ?
-	    (MIPS3_PG_G | MIPS3_PG_RO | MIPS3_PG_WIRED) :
-	    MIPS1_PG_G;
-	pte = kvtopte(l2->l_addr);
-	for (i = 0; i < UPAGES; i++)
-		l2->l_md.md_upte[i] = pte[i].pt_entry &~ x;
-#endif
-
-	pcb = &l2->l_addr->u_pcb;
-	pcb->pcb_context.val[_L_S0] = (intptr_t)func;			/* S0 */
-	pcb->pcb_context.val[_L_S1] = (intptr_t)arg;			/* S1 */
-	pcb->pcb_context.val[MIPS_CURLWP_LABEL] = (intptr_t)l2;		/* T8 */
-	pcb->pcb_context.val[_L_SP] = (intptr_t)tf;			/* SP */
-	pcb->pcb_context.val[_L_RA] = (intptr_t)lwp_trampoline;		/* RA */
+	bool direct_mapped_p = MIPS_KSEG0_P(ua2);
 #ifdef _LP64
-	KASSERT(pcb->pcb_context.val[_L_SR] & MIPS_SR_KX);
-#endif
-	KASSERT(pcb->pcb_context.val[_L_SR] & MIPS_SR_INT_IE);
-}
-
-/*
- * Set the given LWP to start at the given function via the
- * lwp_trampoline.
- */
+	direct_mapped_p = direct_mapped_p || MIPS_XKPHYS_P(ua2);
+#endif
+	if (!direct_mapped_p) {
+		pt_entry_t * const pte = kvtopte(ua2);
+		const uint32_t x = (MIPS_HAS_R4K_MMU) ?
+		    (MIPS3_PG_G | MIPS3_PG_RO | MIPS3_PG_WIRED) : MIPS1_PG_G;
+
+		for (u_int i = 0; i < UPAGES; i++) {
+			l2->l_md.md_upte[i] = pte[i].pt_entry &~ x;
+		}
+	}
+#endif /* !TSAR */
+
+	cpu_setfunc(l2, func, arg);
+}
+
 void
 cpu_setfunc(struct lwp *l, void (*func)(void *), void *arg)
 {
-	struct pcb *pcb = &l->l_addr->u_pcb;
-	struct trapframe *tf = l->l_md.md_utf;
+	struct pcb * const pcb = lwp_getpcb(l);
+	struct trapframe * const tf = l->l_md.md_utf;
 
 	KASSERT(tf == (struct trapframe *)((char *)l->l_addr + USPACE) - 1);
+
+	/*
+	 * Rig kernel stack so that it would start out in lwp_trampoline()
+	 * and call child_return() with l as an argument.  This causes the
+	 * newly-created child process to go directly to user level with a
+	 * parent return value of 0 from fork(), while the parent process
+	 * returns normally.
+	 */
 
 	pcb->pcb_context.val[_L_S0] = (intptr_t)func;			/* S0 */
@@ -209,9 +163,20 @@
 	pcb->pcb_context.val[MIPS_CURLWP_LABEL] = (intptr_t)l;		/* T8 */
 	pcb->pcb_context.val[_L_SP] = (intptr_t)tf;			/* SP */
-	pcb->pcb_context.val[_L_RA] = (intptr_t)setfunc_trampoline;	/* RA */
+	pcb->pcb_context.val[_L_RA] =
+	   mips_locore_jumpvec.ljv_lwp_trampoline;			/* RA */
 #ifdef _LP64
 	KASSERT(pcb->pcb_context.val[_L_SR] & MIPS_SR_KX);
 #endif
 	KASSERT(pcb->pcb_context.val[_L_SR] & MIPS_SR_INT_IE);
+}
+
+/*
+ * Routine to copy MD stuff from proc to proc on a fork.
+ * For mips, this is the ABI and "32 bit process on a 64 bit kernel" flag.
+ */
+void
+cpu_proc_fork(struct proc *p1, struct proc *p2)
+{
+	p2->p_md.md_abi = p1->p_md.md_abi;
 }
 
@@ -230,4 +195,5 @@
 	vaddr_t va;
 	paddr_t pa;
+	struct pcb *pcb = lwp_getpcb(l);
 
 	/*
@@ -256,5 +222,9 @@
 	uarea_ok = uarea_ok && (pa + USPACE - 1 <= MIPS_PHYS_MASK);
 #endif
-	KASSERT((vaddr_t)l->l_addr->u_pcb.pcb_context.val[_L_SP] == (vaddr_t)l->l_md.md_utf);
+	KASSERTMSG(pcb->pcb_context.val[_L_SP] == (intptr_t)l->l_md.md_utf,
+	    ("%s: %s (%#"PRIxREGISTER") != %s (%p)",
+	     __func__,
+	     "pcb->pcb_context.val[_L_SP]", pcb->pcb_context.val[_L_SP],
+	     "(intptr_t)l->l_md.md_utf", l->l_md.md_utf));
 
 	if (!uarea_ok) {
@@ -274,5 +244,5 @@
 		    USPACE_ALIGN, 0, &pglist, 1, 1);
 		if (error)
-			panic("softint_init_md: uvm_pglistalloc failed: %d",
+			panic("%s: uvm_pglistalloc failed: %d", __func__,
 			    error);
 
@@ -298,5 +268,5 @@
 		 */
 		((struct trapframe *)(va + USPACE))[-1] = *l->l_md.md_utf;
-		((struct user *)va)->u_pcb = l->l_addr->u_pcb;
+		*(struct pcb *)va = *pcb;
 		/*
 		 * Discard the old uarea.
@@ -308,5 +278,6 @@
 	l->l_addr = (struct user *)va;
 	l->l_md.md_utf = (struct trapframe *)(va + USPACE) - 1;
-	l->l_addr->u_pcb.pcb_context.val[_L_SP] = (vaddr_t)l->l_md.md_utf;
+	pcb = lwp_getpcb(l);
+	pcb->pcb_context.val[_L_SP] = (vaddr_t)l->l_md.md_utf;
 	uarea_remapped.ev_count++;
 #endif /* !TSAR */
@@ -342,12 +313,18 @@
 cpu_lwp_free(struct lwp *l, int proc)
 {
-
-	if (l->l_md.md_flags & MDP_FPUSED)
-		fpudiscard_lwp(l);
+	KASSERT(l == curlwp);
 
 #ifndef NOFPU
+	fpu_discard();
+
 	KASSERT(l->l_fpcpu == NULL);
 	KASSERT(curcpu()->ci_fpcurlwp != l);
 #endif
+}
+
+vaddr_t
+cpu_lwp_pc(struct lwp *l)
+{
+	return l->l_md.md_utf->tf_regs[_R_PC];
 }
 
@@ -382,9 +359,9 @@
 	}
 
-	if (l->l_md.md_flags & MDP_FPUSED)
-		fpusave_lwp(l);
-
+	fpu_save_lwp(l);
+
+	struct pcb * const pcb = lwp_getpcb(l);
 	cpustate.frame = *l->l_md.md_utf;
-	cpustate.fpregs = l->l_addr->u_pcb.pcb_fpregs;
+	cpustate.fpregs = pcb->pcb_fpregs;
 
 	CORE_SETMAGIC(cseg, CORESEGMAGIC, MID_MACHINE, CORE_CPU);
@@ -401,10 +378,4 @@
 }
 #endif
-
-static struct evcnt evcnt_vmapbuf =
-    EVCNT_INITIALIZER(EVCNT_TYPE_MISC, NULL, "vmapbuf", "calls");
-static struct evcnt evcnt_vmapbuf_adjustments =
-    EVCNT_INITIALIZER(EVCNT_TYPE_MISC, &evcnt_vmapbuf,
-	"vmapbuf", "adjustments");
 
 /*
@@ -419,19 +390,13 @@
 	paddr_t pa;	/* physical address */
 	vsize_t off;
-	vsize_t coloroff;
 
 	if ((bp->b_flags & B_PHYS) == 0)
 		panic("vmapbuf");
 
-	evcnt_vmapbuf.ev_count++;
 	uva = mips_trunc_page(bp->b_saveaddr = bp->b_data);
-	coloroff = uva & ptoa(uvmexp.colormask);
-	if (coloroff)
-		evcnt_vmapbuf_adjustments.ev_count++;
 	off = (vaddr_t)bp->b_data - uva;
 	len = mips_round_page(off + len);
-	kva = uvm_km_alloc(phys_map, len + coloroff, ptoa(uvmexp.ncolors),
-	    UVM_KMF_VAONLY | UVM_KMF_WAITVA);
-	kva += coloroff;
+	kva = uvm_km_alloc(phys_map, len, atop(uva) & uvmexp.colormask,
+	    UVM_FLAG_COLORMATCH | UVM_KMF_VAONLY | UVM_KMF_WAITVA);
 	bp->b_data = (void *)(kva + off);
 	upmap = vm_map_pmap(&bp->b_proc->p_vmspace->vm_map);
@@ -456,5 +421,4 @@
 	vaddr_t kva;
 	vsize_t off;
-	vsize_t coloroff;
 
 	if ((bp->b_flags & B_PHYS) == 0)
@@ -462,10 +426,9 @@
 
 	kva = mips_trunc_page(bp->b_data);
-	coloroff = kva & ptoa(uvmexp.colormask);
 	off = (vaddr_t)bp->b_data - kva;
 	len = mips_round_page(off + len);
 	pmap_remove(vm_map_pmap(phys_map), kva, kva + len);
 	pmap_update(pmap_kernel());
-	uvm_km_free(phys_map, kva - coloroff, len + coloroff, UVM_KMF_VAONLY);
+	uvm_km_free(phys_map, kva, len, UVM_KMF_VAONLY);
 	bp->b_data = bp->b_saveaddr;
 	bp->b_saveaddr = NULL;
Index: /trunk/src/sys/arch/mips/mips/wired_map.c
===================================================================
--- /trunk/src/sys/arch/mips/mips/wired_map.c	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/wired_map.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: wired_map.c,v 1.4.62.1 2010/01/15 06:47:00 matt Exp $	*/
+/*	$NetBSD: wired_map.c,v 1.4.62.2 2010/12/29 00:42:21 matt Exp $	*/
 
 /*-
@@ -64,5 +64,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: wired_map.c,v 1.4.62.1 2010/01/15 06:47:00 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: wired_map.c,v 1.4.62.2 2010/12/29 00:42:21 matt Exp $");
 
 #include <sys/param.h>
@@ -158,5 +158,5 @@
 		    MIPS3_PG_IOPAGE(
 			    PMAP_CCA_FOR_PA(mips3_wired_map[index].pa1));
-	tlb_write_indexed_VPS(MIPS3_TLB_WIRED_UPAGES + index, &tlb);
+	tlb_write_indexed(MIPS3_TLB_WIRED_UPAGES + index, &tlb);
 	return true;
 }
Index: /trunk/src/sys/arch/mips/rmi/rmixl_com.c
===================================================================
--- /trunk/src/sys/arch/mips/rmi/rmixl_com.c	(revision 151)
+++ /trunk/src/sys/arch/mips/rmi/rmixl_com.c	(revision 152)
@@ -1,3 +1,3 @@
-/* $Id: rmixl_com.c,v 1.1.2.12 2010/04/12 22:42:07 cliff Exp $ */
+/* $Id: rmixl_com.c,v 1.1.2.15 2011/05/11 00:37:20 cliff Exp $ */
 /*-
  * Copyright (c) 2006 Urbana-Champaign Independent Media Center.
@@ -102,5 +102,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: rmixl_com.c,v 1.1.2.12 2010/04/12 22:42:07 cliff Exp $");
+__KERNEL_RCSID(0, "$NetBSD: rmixl_com.c,v 1.1.2.15 2011/05/11 00:37:20 cliff Exp $");
 
 #include <sys/param.h>
@@ -126,4 +126,16 @@
 
 #include "opt_com.h"
+
+/* span of UART regs in bytes */
+#define RMIXL_IO_DEV_UART_SIZE	(COM_NPORTS * sizeof(uint32_t))
+
+#define RMIXL_COM_INIT_REGS(regs, bst, ioh, addr) 		\
+	do {							\
+		memset(&regs, 0, sizeof(regs));			\
+		COM_INIT_REGS(regs, bst, ioh, addr);		\
+		regs.cr_nports = RMIXL_IO_DEV_UART_SIZE;	\
+		rmixl_com_initmap(&regs);			\
+	} while (0)
+
 
 struct rmixl_com_softc {
@@ -227,4 +239,5 @@
 	struct obio_attach_args *obio = aux;
 	bus_space_tag_t bst;
+	bus_space_handle_t ioh;
 	bus_addr_t addr;
 	bus_size_t size;
@@ -234,21 +247,17 @@
 	bst = obio->obio_eb_bst;
 	addr = obio->obio_addr;
-	size = obio->obio_size;
+	size = (bus_size_t)RMIXL_IO_DEV_UART_SIZE;
 
 	if (com_is_console(bst, addr, &regs.cr_ioh))
 		return 1;
 
-	if (bus_space_map(bst, addr, size, 0, &regs.cr_ioh))
+	if (bus_space_map(bst, addr, size, 0, &ioh))
 		return 0;		/* FAIL */
 
-	memset(&regs, 0, sizeof(regs));
-	regs.cr_iot = bst;
-	regs.cr_iobase = addr;
-	regs.cr_nports = size;
-	rmixl_com_initmap(&regs);
+	RMIXL_COM_INIT_REGS(regs, bst, ioh, addr);
 
 	rv = com_probe_subr(&regs);
 
-	bus_space_unmap(bst, regs.cr_ioh, size);
+	bus_space_unmap(bst, ioh, size);
 
 	return rv;
@@ -271,5 +280,5 @@
 	bst = obio->obio_eb_bst;
 	addr = obio->obio_addr;
-	size = obio->obio_size;
+	size = (bus_size_t)RMIXL_IO_DEV_UART_SIZE;
 
 	if (!com_is_console(bst, addr, &ioh)
@@ -279,13 +288,10 @@
 	}
 
-	memset(&sc->sc_regs, 0, sizeof(sc->sc_regs));
-	COM_INIT_REGS(sc->sc_regs, bst, ioh, addr);
-	sc->sc_regs.cr_nports = size;
-	rmixl_com_initmap(&sc->sc_regs);
+	RMIXL_COM_INIT_REGS(sc->sc_regs, bst, ioh, addr);
 
 	com_attach_subr(sc);
 
 	rmixl_intr_establish(obio->obio_intr, obio->obio_tmsk,
-		IPL_SERIAL, RMIXL_TRIG_LEVEL, RMIXL_POLR_HIGH,
+		IPL_VM, RMIXL_TRIG_LEVEL, RMIXL_POLR_HIGH,
 		comintr, sc, true);
 
@@ -295,12 +301,8 @@
 rmixl_com_initmap(struct com_regs *regsp)
 {
-	int i;
-	int sz;
-
 	/*
 	 * map the 4 byte register stride
 	 */
-	sz = sizeof(regsp->cr_map) / sizeof(regsp->cr_map[0]);
-	for (i = 0; i < 16; i++)
+	for (int i = 0; i < __arraycount(regsp->cr_map); i++)
 		regsp->cr_map[i] = com_std_map[i] * 4;
 }
@@ -311,15 +313,9 @@
 {
 	bus_space_tag_t bst;
-	bus_size_t sz;
 	struct com_regs	regs;
 
 	bst = (bus_space_tag_t)&rmixl_configuration.rc_obio_eb_memt;
-	sz = COM_NPORTS * sizeof(uint32_t);	/* span of UART regs in bytes */
-
-	memset(&regs, 0, sizeof(regs));
-	rmixl_com_initmap(&regs);
-	regs.cr_iot = bst;
-	regs.cr_iobase = addr;
-	regs.cr_nports = sz;
+
+	RMIXL_COM_INIT_REGS(regs, bst, 0, addr);
 
 	comcnattach1(&regs, speed, freq, type, mode);
Index: /trunk/src/sys/arch/mips/rmi/rmixl_cpu.c
===================================================================
--- /trunk/src/sys/arch/mips/rmi/rmixl_cpu.c	(revision 151)
+++ /trunk/src/sys/arch/mips/rmi/rmixl_cpu.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: rmixl_cpu.c,v 1.1.2.11 2010/05/01 06:10:04 cliff Exp $	*/
+/*	rmixl_cpu.c,v 1.1.2.21 2011/04/29 08:26:31 matt Exp	*/
 
 /*
@@ -39,5 +39,10 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: rmixl_cpu.c,v 1.1.2.11 2010/05/01 06:10:04 cliff Exp $");
+__KERNEL_RCSID(0, "rmixl_cpu.c,v 1.1.2.21 2011/04/29 08:26:31 matt Exp");
+
+#include "opt_multiprocessor.h"
+#include "opt_ddb.h"
+
+#define __MUTEX_PRIVATE
 
 #include <sys/param.h>
@@ -48,5 +53,4 @@
 #include <sys/lwp.h>
 #include <sys/cpu.h>
-#include <sys/user.h>
 #include <sys/malloc.h>
 #include <uvm/uvm_pglist.h>
@@ -61,9 +65,12 @@
 #include <mips/rmi/rmixl_intr.h>
 #include <mips/rmi/rmixl_fmnvar.h>
+#ifdef DDB
+#include <mips/db_machdep.h>
+#endif
 
 
 static int	cpu_rmixl_match(device_t, cfdata_t, void *);
 static void	cpu_rmixl_attach(device_t, device_t, void *);
-static void	cpu_rmixl_attach_once(struct rmixl_cpu_softc * const);
+static void	cpu_rmixl_attach_primary(struct rmixl_cpu_softc * const);
 #ifdef NOTYET
 static int	cpu_fmn_intr(void *, rmixl_fmn_rxmsg_t *);
@@ -72,4 +79,5 @@
 #ifdef MULTIPROCESSOR
 void		cpu_rmixl_hatch(struct cpu_info *);
+void		cpu_rmixl_run(struct cpu_info *);
 #if 0
 static void	cpu_setup_trampoline_ipi(struct device *, struct cpu_info *);
@@ -77,10 +85,11 @@
 static int	cpu_setup_trampoline_common(struct cpu_info *, struct rmixl_cpu_trampoline_args *);
 static void	cpu_setup_trampoline_callback(struct cpu_info *);
+#endif	/* MULTIPROCESSOR */
+
 #ifdef DEBUG
 void		rmixl_cpu_data_print(struct cpu_data *);
 struct cpu_info *
-		rmixl_cpuinfo_print(cpuid_t);
+		rmixl_cpuinfo_print(u_int);
 #endif	/* DEBUG */
-#endif	/* MULTIPROCESSOR */
 
 CFATTACH_DECL_NEW(cpu_rmixl, sizeof(struct rmixl_cpu_softc),
@@ -90,4 +99,59 @@
 static struct rmixl_cpu_trampoline_args rmixl_cpu_trampoline_args;
 #endif
+
+#if defined(DDB)
+/*
+ * cpu_rmixl_watchpoint_init - initialize COP0 watchpoint stuff
+ *
+ * clear IEU_DEFEATURE[DBE] to ensure T_WATCH on watchpoint exception
+ * set COP0 watchhi and watchlo
+ *
+ * disable all watchpoints
+ */
+static void
+cpu_rmixl_watchpoint_init(void)
+{
+	uint32_t r;
+
+	r = rmixl_mfcr(RMIXL_PCR_IEU_DEFEATURE);
+	r &= ~__BIT(7);		/* DBE */
+	rmixl_mtcr(RMIXL_PCR_IEU_DEFEATURE, r);
+
+	cpuwatch_clr_all();
+}
+#endif	/* DDB */
+
+/*
+ * cpu_xls616_erratum
+ *
+ * on the XLS616, COUNT/COMPARE clock regs seem to interact between
+ * threads on a core 
+ *
+ * the symptom of the error is retarded clock interrupts
+ * and very slow apparent system performance
+ *
+ * other XLS chips may have the same problem.
+ * we may need to add other PID checks.
+ */
+static inline bool
+cpu_xls616_erratum(device_t parent, struct cpucore_attach_args *ca)
+{
+#if 0
+	if (mips_options.mips_cpu->cpu_pid == MIPS_XLS616) {
+		if (ca->ca_thread > 0) {
+			aprint_error_dev(parent, "XLS616 CLOCK ERRATUM: "
+				"deconfigure cpu%d\n", ca->ca_thread);
+			return true;
+		}
+	}
+#endif
+	return false;
+}
+
+static bool
+cpu_rmixl_erratum(device_t parent, struct cpucore_attach_args *ca)
+{
+	return cpu_xls616_erratum(parent, ca);
+}
 
 static int
@@ -104,5 +168,6 @@
 	    && ca->ca_thread == 0
 #endif
-	    && (thread == CPUCORECF_THREAD_DEFAULT || thread == ca->ca_thread))
+	    && (thread == CPUCORECF_THREAD_DEFAULT || thread == ca->ca_thread)
+	    && (!cpu_rmixl_erratum(parent, ca)))
 			return 1;
 
@@ -114,8 +179,11 @@
 {
 	struct rmixl_cpu_softc * const sc = device_private(self);
-	struct cpucore_attach_args *ca = aux;
 	struct cpu_info *ci = NULL;
-
-	if (ca->ca_thread == 0 && ca->ca_core == 0) {
+	static bool once = false;
+	extern void rmixl_spl_init_cpu(void);
+	
+	if (once == false) {
+		/* first attach is the primary cpu */
+		once = true;
 		ci = curcpu();
 		sc->sc_dev = self;
@@ -123,21 +191,24 @@
 		ci->ci_softc = (void *)sc;
 
-		cpu_rmixl_attach_once(sc);
+		rmixl_spl_init_cpu();	/* spl initialization for CPU#0 */
+		cpu_rmixl_attach_primary(sc);
 
 #ifdef MULTIPROCESSOR
 		mips_locoresw.lsw_cpu_init = cpu_rmixl_hatch;
+		mips_locoresw.lsw_cpu_run = cpu_rmixl_run;
 	} else {
+		struct cpucore_attach_args * const ca = aux;
 		struct cpucore_softc * const ccsc = device_private(parent);
 		rmixlfw_psb_type_t psb_type = rmixl_configuration.rc_psb_type;
 		cpuid_t cpuid;
-		int s;
-
-		s = splhigh();
 
 		KASSERT(ca->ca_core < 8);
 		KASSERT(ca->ca_thread < 4);
 		cpuid = (ca->ca_core << 2) | ca->ca_thread;
-		ci = cpu_info_alloc(ccsc->sc_tlbinfo, cpuid);
+		ci = cpu_info_alloc(ccsc->sc_tlbinfo, cpuid,
+		    /* XXX */ 0, ca->ca_core, ca->ca_thread);
 		KASSERT(ci != NULL);
+		if (ccsc->sc_tlbinfo == NULL)
+			ccsc->sc_tlbinfo = ci->ci_tlb_info;
 		sc->sc_dev = self;
 		sc->sc_ci = ci;
@@ -165,7 +236,4 @@
 			return;
 		}
-
-		splx(s);
-
 #endif	/* MULTIPROCESSOR */
 	}
@@ -181,19 +249,30 @@
 }
 
+/*
+ * attach the primary processor
+ */
 static void
-cpu_rmixl_attach_once(struct rmixl_cpu_softc * const sc)
-{
-	static bool once = false;
-
-	KASSERT("once != true");
-	if (once == true)
-		return;
-	once = true;
+cpu_rmixl_attach_primary(struct rmixl_cpu_softc * const sc)
+{
+	struct cpu_info *ci = sc->sc_ci;
+	uint32_t ebase;
+
+	KASSERT(CPU_IS_PRIMARY(ci));
+
+	/*
+	 * obtain and set cpuid of the primary processor
+	 */
+	asm volatile("dmfc0 %0, $15, 1;" : "=r"(ebase));
+	ci->ci_cpuid = ebase & __BITS(9,0);
+
+#if defined(DDB)
+	cpu_rmixl_watchpoint_init();
+#endif
 
 	rmixl_fmn_init();
 
-	sc->sc_ih_clk = rmixl_intr_init_clk();
+	rmixl_intr_init_clk();
 #ifdef MULTIPROCESSOR
-	sc->sc_ih_ipi = rmixl_intr_init_ipi();
+	rmixl_intr_init_ipi();
 #endif
 
@@ -206,5 +285,4 @@
 	sc->sc_ih_fmn = ih;
 #endif
-
 }
 
@@ -213,6 +291,6 @@
 cpu_fmn_intr(void *arg, rmixl_fmn_rxmsg_t *rxmsg)
 {
-	if (cpu_number() == 0) {
-		printf("%s: cpu %ld: rxsid=%#x, code=%d, size=%d\n",
+	if (CPU_IS_PRIMARY(curcpu())) {
+		printf("%s: cpu%ld: rxsid=%#x, code=%d, size=%d\n",
 			__func__, cpu_number(),
 			rxmsg->rxsid, rxmsg->code, rxmsg->size);
@@ -227,4 +305,16 @@
 #ifdef MULTIPROCESSOR
 /*
+ * cpu_rmixl_run
+ *
+ * - chip-specific post-running code called from cpu_hatch via lsw_cpu_run
+ */
+void
+cpu_rmixl_run(struct cpu_info *ci)
+{
+	struct rmixl_cpu_softc * const sc = (void *)ci->ci_softc;
+	cpucore_rmixl_run(device_parent(sc->sc_dev));
+}
+
+/*
  * cpu_rmixl_hatch
  *
@@ -234,15 +324,22 @@
 cpu_rmixl_hatch(struct cpu_info *ci)
 {
+	struct rmixl_cpu_softc * const sc = (void *)ci->ci_softc;
+	extern void rmixl_spl_init_cpu(void);
+
+	rmixl_spl_init_cpu();	/* spl initialization for this CPU */
+
 	(void)splhigh();
 
 #ifdef DEBUG
 	uint32_t ebase;
-	asm volatile("dmfc0 %0, $15, 1;" : "=r"(ebase));
+	__asm volatile("dmfc0 %0, $15, 1;" : "=r"(ebase));
 	KASSERT((ebase & __BITS(9,0)) == ci->ci_cpuid);
 	KASSERT(curcpu() == ci);
 #endif
-
-	if (RMIXL_CPU_THREAD(ci->ci_cpuid) == 0)
-		rmixl_fmn_init_core();
+	cpucore_rmixl_hatch(device_parent(sc->sc_dev));
+
+#if defined(DDB)
+	cpu_rmixl_watchpoint_init();
+#endif
 }
 
@@ -283,6 +380,6 @@
 	 *   to rmixl_cpu_trampoline (the upper half is clear)
 	 *   so rmixl_cpu_trampoline must reconstruct the missing upper half
-	 *   rmixl_cpu_trampoline "knows" to use MIPS_KSEG0_START
-	 *   to reconstruct upper half of 'ta'.
+	 *   rmixl_cpu_trampoline "knows" 'ta' is a KSEG0 address
+	 *   and sign-extends to make an LP64 KSEG0 address.
 	 */
 	KASSERT(MIPS_KSEG0_P(ta));
@@ -293,6 +390,5 @@
 	 * forces sign extension of 32 bit pointers
 	 */
-	stacktop = (uintptr_t)l->l_addr + USPACE
-			 - sizeof(struct trapframe) - CALLFRAME_SIZ;
+	stacktop = (uintptr_t)l->l_md.md_utf - CALLFRAME_SIZ;
 	ta->ta_sp = (uint64_t)(intptr_t)stacktop;
 	ta->ta_lwp = (uint64_t)(intptr_t)l;
@@ -322,4 +418,5 @@
 		(uint64_t)1 << ci->ci_cpuid, wakeup_cpu);
 }
+#endif	/* MULTIPROCESSOR */
 
 
@@ -362,7 +459,7 @@
 
 struct cpu_info *
-rmixl_cpuinfo_print(cpuid_t cpuid)
-{
-	struct cpu_info * const ci = cpu_lookup(cpuid);
+rmixl_cpuinfo_print(u_int cpuindex)
+{
+	struct cpu_info * const ci = cpu_lookup(cpuindex);
 
 	if (ci != NULL) {
@@ -386,8 +483,13 @@
 			printf("ci_softlwps[%d] %p\n", i, ci->ci_softlwps[i]);
 		printf("ci_tlb_slot %d\n", ci->ci_tlb_slot);
+		printf("ci_pmap_asid_cur %d\n", ci->ci_pmap_asid_cur);
 		printf("ci_tlb_info %p\n", ci->ci_tlb_info);
-		printf("ci_pmap_segbase %p\n", ci->ci_pmap_segbase);
+		printf("ci_pmap_seg0tab %p\n", ci->ci_pmap_seg0tab);
+#ifdef _LP64
+		printf("ci_pmap_segtab %p\n", ci->ci_pmap_segtab);
+#else
 		printf("ci_pmap_srcbase %#"PRIxVADDR"\n", ci->ci_pmap_srcbase);
 		printf("ci_pmap_dstbase %#"PRIxVADDR"\n", ci->ci_pmap_dstbase);
+#endif
 #ifdef MULTIPROCESSOR
 		printf("ci_flags %#lx\n", ci->ci_flags);
@@ -401,5 +503,3 @@
 	return ci;
 }
-
 #endif	/* DEBUG */
-#endif	/* MULTIPROCESSOR */
Index: /trunk/src/sys/arch/mips/rmi/rmixl_cpucore.c
===================================================================
--- /trunk/src/sys/arch/mips/rmi/rmixl_cpucore.c	(revision 151)
+++ /trunk/src/sys/arch/mips/rmi/rmixl_cpucore.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: rmixl_cpucore.c,v 1.1.2.6 2010/03/21 21:24:19 cliff Exp $	*/
+/*	$NetBSD: rmixl_cpucore.c,v 1.1.2.11 2011/04/29 08:26:31 matt Exp $	*/
 
 /*
@@ -39,5 +39,7 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: rmixl_cpucore.c,v 1.1.2.6 2010/03/21 21:24:19 cliff Exp $");
+__KERNEL_RCSID(0, "$NetBSD: rmixl_cpucore.c,v 1.1.2.11 2011/04/29 08:26:31 matt Exp $");
+
+#include "opt_multiprocessor.h"
 
 #include <sys/param.h>
@@ -51,4 +53,5 @@
 #include <mips/rmi/rmixl_cpunodevar.h>
 #include <mips/rmi/rmixl_cpucorevar.h>
+#include <mips/rmi/rmixl_fmnvar.h>
 
 static int	cpucore_rmixl_match(device_t, cfdata_t, void *);
@@ -85,8 +88,11 @@
 	struct cpucore_attach_args ca;
 	u_int nthreads;
+	struct rmixl_config *rcp = &rmixl_configuration;
 
 	sc->sc_dev = self;
 	sc->sc_core = na->na_core;
-
+	KASSERT(sc->sc_hatched == false);
+
+#if 0
 #ifdef MULTIPROCESSOR
 	/*
@@ -112,4 +118,5 @@
 	}
 #endif
+#endif
 
 	aprint_normal("\n");
@@ -129,11 +136,51 @@
 	/*
 	 * Attach CPU (RMI thread contexts) devices
+	 * according to userapp_cpu_map bitmask.
 	 */
-	for (int i=0; i < nthreads; i++) {
+	u_int thread_mask = (1 << nthreads) - 1;
+	u_int core_shft = sc->sc_core * nthreads;
+	u_int threads_enb =
+		(u_int)(rcp->rc_psb_info.userapp_cpu_map >> core_shft) & thread_mask;
+	u_int threads_dis = (~threads_enb) & thread_mask;
+
+	sc->sc_threads_dis = threads_dis;
+	if (threads_dis != 0) {
+		aprint_normal_dev(self, "threads");
+		u_int d = threads_dis;
+		while (d != 0) {
+			const u_int t = ffs(d) - 1;
+			d ^= (1 << t);
+			aprint_normal(" %d%s", t, (d==0) ? "" : ",");
+		}
+		aprint_normal(" offline (disabled by firmware)\n");
+	}
+
+	u_int threads_try_attach = threads_enb;
+	while (threads_try_attach != 0) {
+		const u_int t = ffs(threads_try_attach) - 1;
+		const u_int bit = 1 << t;
+		threads_try_attach ^= bit;
 		ca.ca_name = "cpu";
-		ca.ca_thread = i;
+		ca.ca_thread = t;
 		ca.ca_core = sc->sc_core;
-		config_found(self, &ca, cpucore_rmixl_print);
-	}
+		if (config_found(self, &ca, cpucore_rmixl_print) == NULL) {
+			/*
+			 * thread did not attach, e.g. not configured
+			 * arrange to have it disabled in THREADEN PCR
+			 */
+			threads_enb ^= bit;
+			threads_dis |= bit;
+		}
+	}
+
+	sc->sc_threads_enb = threads_enb;
+	sc->sc_threads_dis = threads_dis;
+
+	/*
+	 * when attaching the core of the primary cpu,
+	 * do the post-running initialization here
+	 */
+	if (sc->sc_core == RMIXL_CPU_CORE((curcpu()->ci_cpuid)))
+		cpucore_rmixl_run(self);
 }
 
@@ -149,2 +196,43 @@
 	return (UNCONF);
 }
+
+/*
+ * cpucore_rmixl_run
+ *	called from cpucore_rmixl_attach for primary core
+ *	and called from cpu_rmixl_run for each hatched cpu
+ *	the first call for each cpucore causes init of per-core features:
+ *	- disable unused threads
+ *	- set Fine-grained (Round Robin) thread scheduling mode
+ */
+void
+cpucore_rmixl_run(device_t self)
+{
+	struct cpucore_softc * const sc = device_private(self);
+
+	if (sc->sc_running == false) {
+		sc->sc_running = true;
+		rmixl_mtcr(RMIXL_PCR_THREADEN, sc->sc_threads_enb);
+		rmixl_mtcr(RMIXL_PCR_SCHEDULING, 0);
+	}
+}
+
+#ifdef MULTIPROCESSOR
+/*
+ * cpucore_rmixl_hatch
+ *	called from cpu_rmixl_hatch for each cpu
+ *	the first call for each cpucore causes init of per-core features
+ */
+void
+cpucore_rmixl_hatch(device_t self)
+{
+	struct cpucore_softc * const sc = device_private(self);
+
+	if (sc->sc_hatched == false) {
+		/* PCRs for core#0 are set up in mach_init() */
+		if (sc->sc_core != 0)
+			rmixl_pcr_init_core();
+		rmixl_fmn_init_core();
+		sc->sc_hatched = true;
+	}
+}
+#endif	/* MULTIPROCESSOR */
Index: /trunk/src/sys/arch/mips/rmi/rmixl_cpucorevar.h
===================================================================
--- /trunk/src/sys/arch/mips/rmi/rmixl_cpucorevar.h	(revision 151)
+++ /trunk/src/sys/arch/mips/rmi/rmixl_cpucorevar.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: rmixl_cpucorevar.h,v 1.1.2.3 2010/04/13 18:15:16 cliff Exp $	*/
+/*	$NetBSD: rmixl_cpucorevar.h,v 1.1.2.7 2011/04/29 08:26:31 matt Exp $	*/
 /*-
  * Copyright (c) 2010 The NetBSD Foundation, Inc.
@@ -32,11 +32,18 @@
 #define _ARCH_MIPS_RMI_RMIXL_CPUCOREVAR_H_
 
+#ifdef _KERNEL_OPT
+#include "opt_multiprocessor.h"
+#endif
+
 struct cpucore_softc {
 	device_t	sc_dev;
+	u_int		sc_core;
+	u_int		sc_threads_enb;
+	u_int		sc_threads_dis;
 	bool		sc_attached;
-	u_int		sc_core;
+	bool		sc_running;
+	bool		sc_hatched;
 #ifdef MULTIPROCESSOR
 	struct pmap_tlb_info *sc_tlbinfo;
-	struct pmap_tlb_info sc_tlbinfo0;
 #endif
 };
@@ -48,3 +55,8 @@
 };
 
+#ifdef _KERNEL
+void cpucore_rmixl_hatch(device_t);
+void cpucore_rmixl_run(device_t);
+#endif
+
 #endif	/* _ARCH_MIPS_RMI_RMIXL_CPUCOREVAR_H_ */
Index: /trunk/src/sys/arch/mips/rmi/rmixl_cpuvar.h
===================================================================
--- /trunk/src/sys/arch/mips/rmi/rmixl_cpuvar.h	(revision 151)
+++ /trunk/src/sys/arch/mips/rmi/rmixl_cpuvar.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: rmixl_cpuvar.h,v 1.1.2.2 2010/04/13 18:15:16 cliff Exp $	*/
+/*	$NetBSD: rmixl_cpuvar.h,v 1.1.2.3 2011/02/08 19:50:22 cliff Exp $	*/
 /*-
  * Copyright (c) 2010 The NetBSD Foundation, Inc.
@@ -41,7 +41,4 @@
 	device_t sc_dev;
 	struct cpu_info *sc_ci;
-	void *sc_ih_clk;
-	void *sc_ih_fmn;
-	void *sc_ih_ipi;
 	struct evcnt sc_vec_evcnts[64];
 };
